/*
 *  @(#)dollar_atomic_1.cs
 *  $B=R8l(B $atomic/1
 */

namespace JJC.Psharp.Predicates {

	using JJC.Psharp.Lang;

	public sealed class dollar_atomic_1 : Predicate {
		Term arg1;

		public dollar_atomic_1(Term a1, Predicate cont) {
			arg1 = a1;
			this.cont = cont;
		}
		public dollar_atomic_1() {}
		public override void setArgument(Term[] args, Predicate cont){
			arg1 = args[0];
			this.cont = cont;
		}

		public override Predicate exec() {
			Term a1;
			a1 = arg1.dereference();

			if( !a1.isSymbol() && !a1.isInteger() )
				return engine.fail();
			return cont;
		}

		public override int arity() { return 1 ; }

		public override string ToString() {
			return "$atomic(" + arg1 + ")";
		}
	}

}