/*
 * @(#)dollar_csSetField_3.java
 * $B=R8l(B $java_set_field/3
 */
// import java.util.*;
// import java.lang.*;
// import java.lang.reflect.*;

namespace JJC.Psharp.Predicates {

	using JJC.Psharp.Lang;
	using System;

	public sealed class dollar_csSetField_3 : Predicate {
		Term arg1, arg2, arg3;

		public dollar_csSetField_3(Term a1, Term a2, Term a3, Predicate cont) {
			arg1 = a1;
			arg2 = a2;
			arg3 = a3;
			this.cont = cont;
		}
		public dollar_csSetField_3() {}
		public override void setArgument(Term[] args, Predicate cont){
			arg1 = args[0];
			arg2 = args[1];
			arg3 = args[2];
			this.cont = cont;
		}

		public override Predicate exec() {
			Term a1, a2, a3;
			a1 = arg1.dereference();
			a2 = arg2.dereference();
			a3 = arg3.dereference();

			try {
				Type type = null;
				object obj = null;
				//	    Object value = null;
				System.Reflection.FieldInfo field = null;

				if ( a1.isSymbol() ) {
					type = AssemblyList.GetAnyType( ((SymbolTerm)a1).name );
					//clazz = Class.forName(((SymbolTerm)a1).name());
				}
				else if ( a1.isCsObject() ) {
					obj = ((CsObjectTerm)a1).Object();
					type = obj.GetType();
					//		clazz = obj.getClass();
				} else {
					return engine.abort("{TYPE ERROR: " + this +
						" expected class or instance, found " + 
						a1 + "}\n");
				}
				if ( a2.isSymbol() ){ // $BBhFs0z?t$O%U%#!<%k%I(B
					field = type.GetField(((SymbolTerm)a2).name);
					//		value = field.get(obj);
				}
				else {
					return engine.abort("{TYPE ERROR: " + this +
						" expected field, found " + 
						a2 + "}\n");
				}
				field.SetValue(obj, a3.toCsObject());  // $BBh;00z?t$O%U%#!<%k%I$KCM$r%;%C%H(B
				return cont;
				/*
			} catch (NoSuchFieldException e1) {
				e1.printStackTrace();
				return engine.abort("{NO SUCH FIELD ERROR: " + this + "}\n");
			} catch (SecurityException e2) {
				e2.printStackTrace();
				return engine.abort("{SECURITY ERROR: " + this + "}\n");
			} catch (IllegalArgumentException e3) {
				e3.printStackTrace();
				return engine.abort("{ILLEGAL ARGUMENT ERROR: " + this + "}\n");
			} catch (IllegalAccessException e4) {
				e4.printStackTrace();
				return engine.abort("{ILLEGAL ACCESS ERROR: " + this + "}\n");
			} catch (NullPointerException e5) {
				e5.printStackTrace();
				return engine.abort("{NULL POINTER ERROR: " + this + "}\n");
				*/
			} catch (Exception) {
				return engine.abort("{CS ERROR: " + this + "}\n");
			}
			//	return cont;
		}

		public override int arity() { return 3; }
		public override string ToString() {
			return "$java_set_field(" + arg1 + "," + arg2 + "," + arg3 + ")";
		}
	}
}