/*
 * @(#)dollar_cut_1.cs
 * $BFCJL=R8l(B $cut/1 (!/0)
 */

namespace JJC.Psharp.Predicates {

	using JJC.Psharp.Lang;

	public sealed class dollar_cut_1 : Predicate {
		Term arg1;

		public dollar_cut_1(Term a1, Predicate cont) {
			arg1 = a1;
			this.cont = cont;
		}
		public dollar_cut_1() {}
		public override void setArgument(Term[] args, Predicate cont){
			arg1 = args[0];
			this.cont = cont;
		}

		public override Predicate exec() {
			Term a1;
			a1 = arg1.dereference();

			if ( !a1.isInteger() ) 
				return engine.fail();
			int i = ((IntegerTerm)a1).value();
			engine.cut(i);
			return cont;
		}

		public override int arity() { return 1; }

		public override string ToString() {
			return "$cut(" + arg1 + ")";
		}
	}

}