/*
 * @(#)dollar_openTable_1.cs
 * $B=R8l(B $open_table/1
 */

namespace JJC.Psharp.Predicates {

	using JJC.Psharp.Lang;

	using System.Collections;

	public sealed class dollar_openTable_1 : Predicate {
		Term arg1;

		public dollar_openTable_1(Term a1, Predicate cont) {
			arg1 = a1;
			this.cont = cont;
		}
		public dollar_openTable_1() {}
		public override void setArgument(Term[] args, Predicate cont){
			arg1 = args[0];
			this.cont = cont;
		}

		public override Predicate exec() {
			Term a1;
			a1 = arg1.dereference();
			CsObjectTerm jTerm;

			jTerm = new CsObjectTerm(new Hashtable());
			if ( !a1.unify(jTerm, engine.trail) ) 
				return engine.fail();
			return cont;
		}

		public override int arity() { return 1; }
		public override string ToString() {
			return "$open_table(" + arg1 + ")";
		}
	}

}