/*
 *  @(#)dollar_standardError_1.cs
 */

namespace JJC.Psharp.Predicates {

	using JJC.Psharp.Lang;

	public sealed class dollar_standardError_1 : Predicate {
		Term arg1;

		public dollar_standardError_1(Term a1, Predicate cont) {
			arg1 = a1;
			this.cont = cont;
		}
		public dollar_standardError_1() {}
		public override void setArgument(Term[] args, Predicate cont){
			arg1 = args[0];
			this.cont = cont;
		}

		public override Predicate exec() {
			Term a1;
			a1 = arg1.dereference();
			CsObjectTerm jTerm;

			jTerm = new CsObjectTerm(engine.user_error);
			if ( !a1.unify(jTerm, engine.trail) ) 
				return engine.fail();
			return cont;
		}

		public override int arity() { return 1; }
		public override string ToString() {
			return "$standard_error(" + arg1 + ")";
		}
	}

}