/*
 *  @(#)dollar_fastWrite_1.cs
 *  $B=R8l(B $fast_write/1
 */

namespace JJC.Psharp.Predicates {

	using JJC.Psharp.Lang;

	public sealed class dollar_fastWrite_1 : Predicate {
		Term arg1;

		public dollar_fastWrite_1(Term a1, Predicate cont) {
			arg1 = a1;
			this.cont = cont;
		}
		public dollar_fastWrite_1() {}
		public override void setArgument(Term[] args, Predicate cont){
			arg1 = args[0];
			this.cont = cont;
		}

		public override Predicate exec() {
			Term a1;
			a1 = arg1.dereference();

			Token.write_string(a1.ToString(), engine.current_output);
			return cont;
		}

		public override int arity() { return 1; }

		public override string ToString() {
			return "$fast_write(" + arg1 + ")";
		}
	}

}