/*
 * @(#)dollar_notBefore_2.cs
 * $B=R8l(B @>=/2
 */

namespace JJC.Psharp.Predicates {

	using JJC.Psharp.Lang;

	public sealed class dollar_notBefore_2 : Predicate {
		Term arg1, arg2;

		public dollar_notBefore_2(Term a1, Term a2, Predicate cont) {
			arg1 = a1;
			arg2 = a2;
			this.cont = cont;
		}
		public dollar_notBefore_2() {}
		public override void setArgument(Term[] args, Predicate cont){
			arg1 = args[0];
			arg2 = args[1];
			this.cont = cont;
		}

		public override Predicate exec() {
			int i = Prolog.compareTerm(arg1, arg2);
			if ( i < 0 ) 
				return engine.fail();
			return cont;
		}

		public override int arity() { return 2; }
		public override string ToString() {
			return "(" + arg1 + " @>= " + arg2 + ")";
		}
	}

}