/*
 * @(#)dollar_putTerm_2.cs
 * $B=R8l(B $put_term/2
 */

namespace JJC.Psharp.Predicates {

	using JJC.Psharp.Lang;

	using System.Collections;

	public sealed class dollar_putTerm_2 : Predicate {
		Term arg1, arg2;

		public dollar_putTerm_2(Term a1, Term a2, Predicate cont) {
			arg1 = a1;
			arg2 = a2;
			this.cont = cont;
		}
		public dollar_putTerm_2() {}
		public override void setArgument(Term[] args, Predicate cont){
			arg1 = args[0];
			arg2 = args[1];
			this.cont = cont;
		}

		public override Predicate exec() {
			Term a1, a2;
			a1 = arg1.dereference();
			a2 = arg2.dereference();
			string key;

			key = a1.ToString();
			if( engine.current_table.ContainsKey( key ) )
				engine.current_table.Remove( key );
			engine.current_table.Add(key, a2);
			return cont;
		}

		public override int arity() { return 2; }
		public override string ToString() {
			return "$put_term(" + arg1 + "," + arg2 + ")";
		}
	}

}