/*
 * @(#)dollar_tab_1.cs
 *  $B=R8l(B $tab/1
 */

namespace JJC.Psharp.Predicates {

	using JJC.Psharp.Lang;

	public sealed class dollar_tab_1 : Predicate {
		Term arg1;

		public dollar_tab_1(Term a1, Predicate cont) {
			arg1 = a1;
			this.cont = cont;
		}
		public dollar_tab_1() {}
		public override void setArgument(Term[] args, Predicate cont){
			arg1 = args[0];
			this.cont = cont;
		}

		public override Predicate exec() {
			try {
				int tab = engine.evalTerm(arg1);
				for (int i=tab; i>0; i--) {
					engine.current_output.Write(' ');
				}
			} catch (ArithException) {
				return engine.abort("{TYPE ERROR: " + this + 
					" - arg 1: expected expression, found " +
					arg1 + "}");
			}
			return cont;
		}

		public override int arity() { return 1; }
		public override string ToString() {
			return "$tab(" + arg1 + ")";
		}	
	}

}